//
//  RunningStat.h
//  ManuScore
//
//  Created by James Maxwell on 11-10-03.
//  Copyright 2011 rubato-music.com. All rights reserved.
//

#import <Foundation/Foundation.h>


@interface RunningStat : NSObject {
@private
    UInt64 m_n;
    double m_oldM, m_newM, m_oldS, m_newS;
}

- (void)        Clear;
- (void)        Push:(double)x;
- (UInt64)      NumDataValues;
- (double)      Mean;
- (double)      Variance;
- (double)      StandardDeviation;

@end

/***
 
 This is an Obj-C implementation of Knuth's algorithm (from Welford).
 
 */
