//
//  mcCMMotive.h
//  MusiCog
//
//  Created by James Maxwell on 2013-06-13.
//  Copyright (c) 2013 James Maxwell. All rights reserved.
//

#import <Foundation/Foundation.h>

@class mcCMEdge;

@interface mcCMMotive : NSObject<NSCopying>

@property (strong, nonatomic) mcCMEdge* pitchBoundary;
@property (strong, nonatomic) mcCMEdge* pitchTerminal;
@property (strong, nonatomic) mcCMEdge* rhythmBoundary;
@property (strong, nonatomic) mcCMEdge* rhythmTerminal;
@property (strong, nonatomic) NSMutableArray* pitchBranch;
@property (strong, nonatomic) NSMutableArray* rhythmBranch;

- (void) updateCounts;
- (void) updateRhythmBranchWithEdge:(/*__unsafe_unretained*/ mcCMEdge*)anEdge;
- (void) updatePitchBranchWithEdge:(/*__unsafe_unretained*/ mcCMEdge*)anEdge;
- (NSArray*) sourceModeAndTonalityForPhrase;

@end
