//
//  mcMusicPlayer.h
//  MusiCog
//
//  Created by James Maxwell on 2013-06-09.
//  Copyright (c) 2013 James Maxwell. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <AudioToolbox/AudioToolbox.h>
#import "mcMusicPlayerController.h"

@interface mcMusicPlayer : NSObject

@property (weak, nonatomic) mcMusicPlayerController* controller;
@property (assign, nonatomic) MusicPlayer player;
@property (assign, nonatomic) MusicSequence sequence;
@property (assign, nonatomic) MusicSequence MIDIFileSequence;
@property (assign, nonatomic) MusicTrack userTrack;
@property (assign, nonatomic) MusicTimeStamp sequenceLength;
@property (assign, nonatomic) MusicTimeStamp startTime;
@property (assign, nonatomic) MusicTimeStamp currentTime;
@property (assign, nonatomic) BOOL MIDIFileLoaded;
@property (assign, nonatomic) BOOL MIDIFileParsingComplete;
@property (assign, nonatomic) BOOL sequenceIsPlaying;
@property (strong, nonatomic) NSString* loadedMIDIFileName;
@property (strong, nonatomic) NSMutableArray* tracksForParsing;
@property (strong, nonatomic) NSMutableDictionary* parsedMIDIFileDataByTrack;
@property (strong, nonatomic) NSMutableArray* MIDIFilesToAnalyze;
@property (strong, nonatomic) NSURL* seedMIDIFile;

- (MusicTimeStamp) playerCurrentTime;
- (void) parseSequence:(MusicSequence)aSequence;
- (void) clearMIDIFileSequence;
- (BOOL) initSequencer;
- (BOOL) setCallback;
- (void) addEventWithPitch:(UInt)pitch
                  velocity:(UInt)velocity
              articulation:(NSInteger)articulation
                      bend:(NSInteger)bendValue
                    atTime:(MusicTimeStamp)timestamp
              withDuration:(MusicTimeStamp)duration
               forStreamID:(UInt16)streamID
             addUserEvents:(BOOL)flag;
- (void) makeSequenceLegato:(MusicSequence)aSequence;
- (Float64) getBeatsForMSTimestamp:(UInt64)ms_timestamp;
- (void) playSequence;
- (void) stopSequence;
-(void)	PlayLoopWithPlayer:(MusicPlayer)aPlayer forSequenceLength:(MusicTimeStamp)length willCycle:(BOOL)flag;
- (id) initWithController:(mcMusicPlayerController*)aController;

@end
