//
//  mcNEvent.h
//  MusiCog
//
//  Created by James Maxwell on 2013-11-10.
//  Copyright (c) 2013 James Maxwell. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <AudioToolbox/AudioToolbox.h>

typedef struct __attribute__((packed)) MCMusicEvent {
    Boolean status;             // used by the MusicPlayer callback
    UInt8 pitch;                // MIDI pitch (also Identity rep)
    UInt8 velocity;             // MIDI velocity
    UInt8 channel;              // 1-16
    UInt16 trackID;             // used by the MusicPlayer callback -- Nov build: use as streamID
    UInt32 typeID;              // used by the MusicPlayer callback
    UInt32 length;              // required by Core Audio's user event type
    long ms_duration;           // for max compatibility
    MusicTimeStamp timestamp;   // timestamp in beats
    MusicTimeStamp duration;    // duration in beats
} MCMusicEvent;

@interface mcNEvent : NSObject

@property (strong, nonatomic) mcNEvent* prevEvent;
@property (assign, nonatomic) MCMusicEvent* musicEvent;

- (NSUInteger) eInterval;       // i.e., "encoded" interval (0 - 255)
- (UInt8) generatePitchWithEInterval:(NSUInteger)eInterval;

@end
