//
//  mcWMController.h
//  MusiCog
//
//  Created by James Maxwell on 2013-06-08.
//  Copyright (c) 2013 James Maxwell. All rights reserved.
//

#import <Foundation/Foundation.h>

@class mcMusiCogController, mcWMStream, mcWMSegment, mcCMModel, mcCMNode;

@interface mcWMController : NSObject

@property (assign, nonatomic) mcMusiCogController* musiCog;
@property (strong, nonatomic) NSMutableArray* groups;
@property (strong, nonatomic) NSMutableArray* activeStreams;
@property (strong, nonatomic) NSMutableDictionary* stateChanges;
@property (strong, nonatomic) mcWMSegment* inferenceSegment;

- (mcWMStream*) getStreamAtStreamID:(NSUInteger)streamID;
- (void) buildContinuousGroupsListFromMIDIData:(NSMutableDictionary*)midiDataByTrack;
- (void) processGroupsListWithMusiCog;
- (NSArray*) pitchSortedActiveStreams;
- (void) updateWorkingMemory;
- (void) inferAbstractFormOfStream:(mcWMStream*)aStream;
- (void) updateSalienceForContentsOfStream:(mcWMStream*)aStream givenElement:(id)anElement;
- (void) updateStateWithInference:(mcCMNode*)inference forStream:(mcWMStream*)aStream;
- (BOOL) replaceChunksInStream:(mcWMStream*)aStream withChunkSegment:(mcWMSegment*)aSegment;
- (BOOL) replaceSegment:(mcWMSegment *)aSegment inStream:(mcWMStream *)aStream withChunk:(mcWMSegment *)aChunk;
- (void) updateAssociations;
- (NSArray*) extractNoteSegments;
- (mcWMSegment*) stochasticSelectionOfSalientNoteSegmentForModel:(mcCMModel*)aModel;
- (void) reset;
- (id) initWithMusiCog:(mcMusiCogController*)mc;

@end
